/*
 * Copyright (c) 1999, 2000, 2001 The University of Utah and the Flux Group.
 * All rights reserved.
 *
 * @JANOS_CONFIGURE_GNU_LICENSE@
 *
 * Each test is copied to 'conftestJavac.java' before the compiler
 * is run over it.
 */

/**
 * A test case for handling inner classes and blank final fields.
 * <p>
 * If you see an error like:
 * <pre>
 * conftestJavac.java:15: Blank final variable 'staticObj' may not have been initialized.
 * It must be assigned a value in an initializer, or in every constructor.
 *      private static final Object staticObj;
 * </pre>
 * then your java compiler is stupid.  We don't dumb down our code for
 * stupid compilers.  Get jikes, it will compile our code.
 *
 * %AUTHOR_PAT%
 */
public class conftestJavac
{
	private static final Object staticObj;
	public final int a;
	public InnerClass ic;
	
	private static class InnerStaticClass
	{
		public final Object o;
		
		public InnerStaticClass()
		{
			o = staticObj;
		}
	}
	
	static {
		staticObj = new Object();
	}
	
	private class InnerClass {
		int a;
	}
	
	public static void main(String[] args)
	{
		Object t = new conftestJavac(1);
	}
	
	public conftestJavac(int a) 
	{
		if (a > 2) 
			throw new NullPointerException();
		this.a = a;
		this.ic = new InnerClass();
	}
}
