###
### Java.mk
###
### Copyright (c) 1999, 2000 The University of Utah and the Flux Group.
### All rights reserved.
###
### This file is part of the Janos Java NodeOS software.
### 
### Permission to use, copy, modify, distribute, and sell this software and
### its documentation is hereby granted without fee, provided that the above
### copyright notice and this permission/disclaimer notice is retained in all
### copies or modified versions, and that both notices appear in supporting
### documentation.  THE COPYRIGHT HOLDERS PROVIDE THIS SOFTWARE "AS IS" AND
### WITHOUT ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION,
### THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
### PURPOSE.  THE COPYRIGHT HOLDERS DISCLAIM ANY LIABILITY OF ANY KIND FOR
### ANY DAMAGES WHATSOEVER RESULTING FROM THE USE OF THIS SOFTWARE.
### 
### Users are requested, but not required, to send to csl-dist@cs.utah.edu any
### improvements that they make and grant Univ. of Utah redistribution rights.
###

###
### This file must define a single make variable 'COMPILE_JAVA'.  It will be
### used like this: $(COMPILE_JAVA) [lots of files]
###
### This file should define real rules (other than mkdebug::)
###
### The following variables can be expected to be defined:
###  BUILD, LIBSTYLE, PACKAGE_PREFIX, PACKAGE_PREFIX_DIR, DEST_DIR
### The following variable will have defaults honored:
###  JAVA_COMPILER, JAVA_CLASSPATH
###
### XXX Watch out for name clashes, only one namespace in make.
###

### The actual compiler script/executable  [default to jikes]
ifndef JAVA_COMPILER
JAVA_COMPILER:=jikes
#JAVA_COMPILER:=javac
#JAVA_COMPILER:=/usr/local/java/bin/javac
endif

### For setting up classpath for compiler
ifdef JAVA_CLASSPATH
JAVA_SET_CLASSPATH:=CLASSPATH=$${CLASSPATH}:${JAVA_CLASSPATH}:${DEST_DIR}
else
JAVA_SET_CLASSPATH:=CLASSPATH=$${CLASSPATH}:${DEST_DIR}
endif

### Defines for jikes:
jikes_FLAGS_DEFAULT:=+P +E +D +Z  # XXX Don't check in +D change!
jikes_FLAGS_debug:=-g
jikes_FLAGS_optimized:=-O
jikes_FLAGS_exposed:=-g

### Defines for Sun's javac:
javac_FLAGS_DEFAULT:=
javac_FLAGS_debug:=-g
javac_FLAGS_optimized:=-O
javac_FLAGS_exposed:=-g

### XXX defines for gcj?

### Given the configuration and the Java setup, define the implied javac flags:
JAVAC_FLAGS:=$($(JAVA_COMPILER)_FLAGS_DEFAULT) $($(JAVA_COMPILER)_FLAGS_$(BUILD))

### This is what this file is defined to do:
COMPILE_JAVA:=$(JAVA_SET_CLASSPATH) $(JAVA_COMPILER) $(JAVAC_FLAGS)

###
### mkdebug targets
###

mkdebug:: mkdebug_Java.mk

mkdebug_Java.mk::
	@echo 
	@echo "**** Java.mk settings:"
	@echo 
	@echo "    JAVA_COMPILER   = '$(JAVA_COMPILER)'"
	@echo "    JAVAC_FLAGS     = '$(JAVAC_FLAGS)'"
	@echo "    COMPILE_JAVA    = '$(COMPILE_JAVA)'"

.PHONY: mkdebug_Java.mk
