/*
 * MemoryChewer.Java
 *
 * Copyright (c) 2000 The University of Utah and the Flux Group.
 * All rights reserved.
 * 
 * This file is part of the Janos Java NodeOS software.
 * 
 * Permission to use, copy, modify, distribute, and sell this software and
 * its documentation is hereby granted without fee, provided that the above
 * copyright notice and this permission/disclaimer notice is retained in all
 * copies or modified versions, and that both notices appear in supporting
 * documentation.  THE COPYRIGHT HOLDERS PROVIDE THIS SOFTWARE "AS IS" AND
 * WITHOUT ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION,
 * THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE.  THE COPYRIGHT HOLDERS DISCLAIM ANY LIABILITY OF ANY KIND FOR
 * ANY DAMAGES WHATSOEVER RESULTING FROM THE USE OF THIS SOFTWARE.
 * 
 * Users are requested, but not required, to send to csl-dist@cs.utah.edu any
 * improvements that they make and grant Univ. of Utah redistribution rights.
 */
package JANOS_BENCHMARKS_PKG;

import java.util.Vector;

import JANOS_NODEOS_PKG.Node;
import JANOS_NODEOS_PKG.Domain;
import JANOS_NODEOS_PKG.DomainRun;
import JVM_COMMSPACE_PKG.CommSpaceHandle;

public class MemoryChewer
	extends DomainRun
{
	protected void run(Domain domain, String args[], CommSpaceHandle csh)
	{
		/*
		 * Use an array since we can't be sure a stack value
		 * is really nulled out or not.
		 */
		Object root[] = { null };
		Object curr[] = null;
		int id, lpc = 0;

		try
		{
			id = Integer.parseInt(args[0]);
		}
		catch(NumberFormatException e)
		{
			id = 0;
		}
		while( true )
		{
			try
			{
				if( curr == null )
				{
					curr = new Object[10];
					root[0] = curr;
				}
				else
				{
					curr[0] = new Object[10];
					curr[1] = new Object[10];
					curr = (Object [])curr[1];
				}
				lpc++;
				if( (lpc % 10000) == 0 )
					Node.println("Work finished by " + id);
			}
			catch(OutOfMemoryError e)
			{
				root[0] = null;
				curr = null;
			}
		}
	}
}
