/*
 * WorkerBee.Java
 *
 * Copyright (c) 2000 The University of Utah and the Flux Group.
 * All rights reserved.
 * 
 * This file is part of the Janos Java NodeOS software.
 * 
 * Permission to use, copy, modify, distribute, and sell this software and
 * its documentation is hereby granted without fee, provided that the above
 * copyright notice and this permission/disclaimer notice is retained in all
 * copies or modified versions, and that both notices appear in supporting
 * documentation.  THE COPYRIGHT HOLDERS PROVIDE THIS SOFTWARE "AS IS" AND
 * WITHOUT ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION,
 * THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE.  THE COPYRIGHT HOLDERS DISCLAIM ANY LIABILITY OF ANY KIND FOR
 * ANY DAMAGES WHATSOEVER RESULTING FROM THE USE OF THIS SOFTWARE.
 * 
 * Users are requested, but not required, to send to csl-dist@cs.utah.edu any
 * improvements that they make and grant Univ. of Utah redistribution rights.
 */
package JANOS_BENCHMARKS_PKG;

import JANOS_NODEOS_PKG.Domain;
import JANOS_NODEOS_PKG.Node;
import JANOS_NODEOS_PKG.DomainRun;
import JANOS_NODEOS_PKG.MemSpec;
import JANOS_NODEOS_PKG.Credentials;
import JANOS_NODEOS_PKG.DomainStartSpec;
import JANOS_NODEOS_PKG.ThreadPoolSpec;
import JVM_COMMSPACE_PKG.CommSpaceHandle;
import JVM_COMMSPACE_PKG.CommSpaceElement;

public class WorkerBee
	extends DomainRun
{
	protected void run(Domain domain,
			   String args[],
			   CommSpaceHandle csh)
	{
		CommSpaceElement cse;
		int id, i, j;
		
		try
		{
			id = Integer.parseInt(args[0]);
		}
		catch(NumberFormatException e)
		{
			id = 0;
		}
		Node.println("Hello this is " + id);
		cse = new CommSpaceElement(id);
		for( i = 0; i < 10000000; i++ )
		{
			for( j = 0; j < 50000000; j++ )
			{
				/* Do "Work" */
			}
			Node.println("Work finished by " + id);
		}
	}
}
