/*
 * ChanStats.Java
 *
 * Copyright (c) 2000, 2001 The University of Utah and the Flux Group.
 * All rights reserved.
 * 
 * This file is part of the Janos Java NodeOS software.
 * 
 * Permission to use, copy, modify, distribute, and sell this software and
 * its documentation is hereby granted without fee, provided that the above
 * copyright notice and this permission/disclaimer notice is retained in all
 * copies or modified versions, and that both notices appear in supporting
 * documentation.  THE COPYRIGHT HOLDERS PROVIDE THIS SOFTWARE "AS IS" AND
 * WITHOUT ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION,
 * THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE.  THE COPYRIGHT HOLDERS DISCLAIM ANY LIABILITY OF ANY KIND FOR
 * ANY DAMAGES WHATSOEVER RESULTING FROM THE USE OF THIS SOFTWARE.
 * 
 * Users are requested, but not required, to send to csl-dist@cs.utah.edu any
 * improvements that they make and grant Univ. of Utah redistribution rights.
 */
package JANOS_NODEOS_PKG;

/**
 * ChanStats is used to store statistics pertaining to in/out channels in the
 * system.
 *
 * XXX This interface is pretty terrible, we should just have a few functions
 * for each return type (int/long/float) and then pass in a constant
 * indicating which stat we're intereseted in.
 */
public final class ChanStats
	extends NATIVE_CHAN_STATS
{
	public int getInPackets()
	{
		return super.getInPackets();
	}
	
	public long getInBytes()
	{
		return super.getInBytes();
	}
	
	public int getOutPackets()
	{
		return super.getOutPackets();
	}
	
	public long getOutBytes()
	{
		return super.getOutBytes();
	}
	
	public int getDropPackets()
	{
		return super.getDropPackets();
	}
	
	public int getDropNoBufs()
	{
		return super.getDropNoBufs();
	}
	
	public int getDropFailedBuf()
	{
		return super.getDropFailedBuf();
	}
	
	public int getDropBadPacket()
	{
		return super.getDropBadPacket();
	}
	
	public long getDropBytes()
	{
		return super.getDropBytes();
	}
	
	public int getInBufQueued()
	{
		return super.getInBufQueued();
	}
	
	public int getInBufCopies()
	{
		return super.getInBufCopies();
	}
	
	public int getOutBufCopies()
	{
		return super.getOutBufCopies();
	}
	
	public int getMaxThreads()
	{
		return super.getMaxThreads();
	}

	/**
	 * @return The length, in bytes, of the space required
	 * to store a linearized version of this stats
	 * buffer.
	 */
	public int getLength()
	{
		return super.getLength();
	}
	
	/**
	 * @param bh The BufferHandle to marshal the stats into.
	 * @param offset The offset into the BufferHandle where the stats
	 *   should be marshalled.
	 * @return The number of bytes written.
	 */
	public int marshal(BufferHandle bh, int offset)
	{
		return super.marshal(bh.getNativeBufH(), offset);
	}
	
	/**
	 * @param bh The BufferHandle to unmarshal the stats from.
	 * @param offset The position in the buffer where the marshalled stats
	 *   are located.
	 * @return The number of bytes consumed.
	 */
	public int unmarshal(BufferHandle bh, int offset)
	{
		return super.unmarshal(bh.getNativeBufH(), offset);
	}
	
	PACKAGE NATIVE_CHAN_STATS getNative()
	{
		return this;
	}
	
	public String toString()
	{
		return "ChanStats[inPackets="
			+ this.getInPackets()
			+ "; inBytes="
			+ this.getInBytes()
			+ "; outPackets="
			+ this.getOutPackets()
			+ "; outBytes="
			+ this.getOutBytes()
			+ "; dropped="
			+ this.getDropPackets()
			+ "; dropNoBufs="
			+ this.getDropNoBufs()
			+ "; dropFailed="
			+ this.getDropFailedBuf()
			+ "; dropBadPacket="
			+ this.getDropBadPacket()
			+ "; dropBytes="
			+ this.getDropBytes()
			+ "; inBufQueued="
			+ this.getInBufQueued()
			+ "; inBufCopies="
			+ this.getInBufCopies()
			+ "; outBufCopies="
			+ this.getOutBufCopies()
			+ "; maxThreads="
			+ this.getMaxThreads()
			+ "]";
	}
}
