/*
 * CycleTimer.Java
 *
 * Copyright (c) 1999 The University of Utah and the Flux Group.
 * All rights reserved.
 * 
 * This file is part of the Janos Java NodeOS software.
 * 
 * Permission to use, copy, modify, distribute, and sell this software and
 * its documentation is hereby granted without fee, provided that the above
 * copyright notice and this permission/disclaimer notice is retained in all
 * copies or modified versions, and that both notices appear in supporting
 * documentation.  THE COPYRIGHT HOLDERS PROVIDE THIS SOFTWARE "AS IS" AND
 * WITHOUT ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION,
 * THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE.  THE COPYRIGHT HOLDERS DISCLAIM ANY LIABILITY OF ANY KIND FOR
 * ANY DAMAGES WHATSOEVER RESULTING FROM THE USE OF THIS SOFTWARE.
 * 
 * Users are requested, but not required, to send to csl-dist@cs.utah.edu any
 * improvements that they make and grant Univ. of Utah redistribution rights.
 */
package JANOS_NODEOS_PKG;

import java.io.PrintStream;
import java.util.Vector;
import java.util.Enumeration;

/**
 * A table for cycle timer results.
 * <p>
 * XXX Make this more generic.
 *
 * @author <a href="mailto:janos-discuss@flux.cs.utah.edu">Janos Ministry of Development</a>
 */
public class CycleTimerTable
	extends Vector
{
	public void resetAll()
	{
		for(Enumeration e = elements(); e.hasMoreElements();)
		{
			CycleTimer timer = (CycleTimer) e.nextElement();
			timer.reset();
		}
	}

	public void print(PrintStream out)
	{
		String blank = "";

		for(Enumeration e = elements(); e.hasMoreElements();)
		{
			CycleTimer timer = (CycleTimer) e.nextElement();
			while(timer.name.length() > blank.length())
				blank += " ";
		}

		for(Enumeration e = elements(); e.hasMoreElements();)
		{
			CycleTimer timer = (CycleTimer) e.nextElement();
			out.println(
				  timer.name
				+ ": "
				+ blank.substring(timer.name.length())
				+ "\t"
				+ rJust(timer.count)
				+ "\t"
				+ rJust(timer.avg())
				+ "\t"
				+ rJust(timer.stdDev()));
		}
	}

	private String rJust(long n)
	{
		String blank = "          ";
		String s = "" + n;
		return blank.substring(Math.min(s.length(), blank.length())) + s;
	}
}
