/*
 * moab_CutThroughChannel.Java
 *
 * Copyright (c) 2000, 2002 The University of Utah and the Flux Group.
 * All rights reserved.
 * 
 * This file is part of the Janos Java NodeOS software.
 * 
 * Permission to use, copy, modify, distribute, and sell this software and
 * its documentation is hereby granted without fee, provided that the above
 * copyright notice and this permission/disclaimer notice is retained in all
 * copies or modified versions, and that both notices appear in supporting
 * documentation.  THE COPYRIGHT HOLDERS PROVIDE THIS SOFTWARE "AS IS" AND
 * WITHOUT ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION,
 * THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE.  THE COPYRIGHT HOLDERS DISCLAIM ANY LIABILITY OF ANY KIND FOR
 * ANY DAMAGES WHATSOEVER RESULTING FROM THE USE OF THIS SOFTWARE.
 * 
 * Users are requested, but not required, to send to csl-dist@cs.utah.edu any
 * improvements that they make and grant Univ. of Utah redistribution rights.
 */
package JANOS_NODEOS_PKG;

import java.io.IOException;

/**
 * Wrapper for Moab CutThroughChannel.
 * 
 * @see CutThroughChannel
 * @author <a href="mailto:janos-discuss@flux.cs.utah.edu">Janos Ministry of Development</a>
 */
PACKAGE class moab_CutThroughChannel
{
	CHECK_NATIVE_NODEOS

	PACKAGE moab_CutThroughChannel(moab_Domain domain,
				       moab_DemultiplexKey classifier,
				       int threadCount,
				       NetworkSpec outChanNS,
				       String inProtocolSpec,
				       String outProtocolSpec,
				       String inAddressSpec,
				       String outAddressSpec,
				       Address destAddr)
		throws IOException,
		PacketAddressFormatException,
		ProtocolSpecFormatException
	{
		int rc;

		/* XXX DEST ADDR?? */

		panic("This is broken.  Cut Chan's don't deal with protocol specs, addr specs, tps or ns correctly.");

#if 0
		rc = init(domain, classifier,
			  new moab_ThreadPool(inChanTPS, false),
			  outChanNS,
			  inProtocolSpec, outProtocolSpec,
			  inAddressSpec, outAddressSpec);
		assert(rc == 0);
#endif
	}
	
	private native int init(moab_Domain domain,
				moab_DemultiplexKey classifier,
				moab_ThreadPool inChanThreadPool,
				NetworkSpec outChanNS,
				String inProtocolSpec,
				String outProtocolSpec,
				String inAddressSpec,
				String outAddressSpec);
	
	PACKAGE native void native_addBuffer(moab_BufferHandle pb);

	PACKAGE native BufferHandle native_remBuffer();
	
	PACKAGE native void destroy();
}


