/*
 * moab_DomainSpec.Java
 *
 * Copyright (c) 1999, 2000, 2001, 2002 The University of Utah and the Flux Group.
 * All rights reserved.
 * 
 * This file is part of the Janos Java NodeOS software.
 * 
 * Permission to use, copy, modify, distribute, and sell this software and
 * its documentation is hereby granted without fee, provided that the above
 * copyright notice and this permission/disclaimer notice is retained in all
 * copies or modified versions, and that both notices appear in supporting
 * documentation.  THE COPYRIGHT HOLDERS PROVIDE THIS SOFTWARE "AS IS" AND
 * WITHOUT ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION,
 * THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE.  THE COPYRIGHT HOLDERS DISCLAIM ANY LIABILITY OF ANY KIND FOR
 * ANY DAMAGES WHATSOEVER RESULTING FROM THE USE OF THIS SOFTWARE.
 * 
 * Users are requested, but not required, to send to csl-dist@cs.utah.edu any
 * improvements that they make and grant Univ. of Utah redistribution rights.
 */
package JANOS_NODEOS_PKG;

import JVM_RESOURCES_PKG.ResourceSpec;

/**
 * Java wrapper for a moab-specific DomainSpec.  
 * <p>
 * XXX This should be a visible, common-layer class that contains
 * all of the Specs necessary to create a new domain, including 
 * all the relevant sub-specs (mem, gc, threads, etc.).  For now,
 * its a simple resource the VM uses to track and free the underlying
 * Moab domain objects.  See the JanosVM's <code>kaffe/janosvm/resource.h</code>.
 * As such, it doesn't need any actual fields (it is implicitly associated
 * with the domain underlying a specific Team).
 *
 * @see moab_DomainSpec
 * @author <a href="mailto:janos-discuss@flux.cs.utah.edu">Janos Ministry of Development</a>
 */
PACKAGE class moab_DomainSpec
	extends ResourceSpec
{
	CHECK_NATIVE_NODEOS

	public moab_DomainSpec()
	{
		nativeConstructor();
	}

	protected void finalize()
	{
		nativeFinalizer();
	}

	private native void nativeConstructor();

	private native void nativeFinalizer();
}

