/*
 * pj_ChanStats.Java
 *
 * Copyright (c) 2000, 2001 The University of Utah and the Flux Group.
 * All rights reserved.
 * 
 * This file is part of the Janos Java NodeOS software.
 * 
 * Permission to use, copy, modify, distribute, and sell this software and
 * its documentation is hereby granted without fee, provided that the above
 * copyright notice and this permission/disclaimer notice is retained in all
 * copies or modified versions, and that both notices appear in supporting
 * documentation.  THE COPYRIGHT HOLDERS PROVIDE THIS SOFTWARE "AS IS" AND
 * WITHOUT ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION,
 * THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE.  THE COPYRIGHT HOLDERS DISCLAIM ANY LIABILITY OF ANY KIND FOR
 * ANY DAMAGES WHATSOEVER RESULTING FROM THE USE OF THIS SOFTWARE.
 * 
 * Users are requested, but not required, to send to csl-dist@cs.utah.edu any
 * improvements that they make and grant Univ. of Utah redistribution rights.
 */
package JANOS_NODEOS_PKG;

PACKAGE class pj_ChanStats
{
	PACKAGE int inPackets;
	PACKAGE long inBytes;
	PACKAGE int outPackets;
	PACKAGE long outBytes;
	PACKAGE int dropPackets;
	PACKAGE int dropNoBufs;
	PACKAGE int dropFailedBuf;
	PACKAGE int dropBadPacket;
	PACKAGE long dropBytes;
	PACKAGE int inBufQueued;
	PACKAGE int inBufCopies;
	PACKAGE int outBufCopies;
	PACKAGE int maxThreads;

	PACKAGE void copyInto(pj_ChanStats cs)
	{
		cs.inPackets = this.inPackets;
		cs.inBytes = this.inBytes;
		cs.outPackets = this.outPackets;
		cs.outBytes = this.outBytes;
		cs.dropPackets = this.dropPackets;
		cs.dropNoBufs = this.dropNoBufs;
		cs.dropFailedBuf = this.dropFailedBuf;
		cs.dropBadPacket = this.dropBadPacket;
		cs.dropBytes = this.dropBytes;
		cs.inBufQueued = this.inBufQueued;
		cs.inBufCopies = this.inBufCopies;
		cs.outBufCopies = this.outBufCopies;
		cs.maxThreads = this.maxThreads;
	}
	
	PACKAGE int getInPackets()
	{
		return this.inPackets;
	}
	
	
	PACKAGE long getInBytes()
	{
		return this.inBytes;
	}
	
	
	PACKAGE int getOutPackets()
	{
		return this.outPackets;
	}
	
	
	PACKAGE long getOutBytes()
	{
		return this.outBytes;
	}
	
	
	PACKAGE int getDropPackets()
	{
		return this.dropPackets;
	}
	
	
	PACKAGE int getDropNoBufs()
	{
		return this.dropNoBufs;
	}
	
	PACKAGE int getDropFailedBuf()
	{
		return this.dropFailedBuf;
	}
	
	
	PACKAGE int getDropBadPacket()
	{
		return this.dropBadPacket;
	}
	
	
	PACKAGE long getDropBytes()
	{
		return this.dropBytes;
	}
	
	
	PACKAGE int getInBufQueued()
	{
		return this.inBufQueued;
	}
	
	
	PACKAGE int getInBufCopies()
	{
		return this.inBufCopies;
	}
	
	
	PACKAGE int getOutBufCopies()
	{
		return this.outBufCopies;
	}
	
	
	PACKAGE int getMaxThreads()
	{
		return this.maxThreads;
	}
	

	PACKAGE int getLength()
	{
		return 0;
	}
	
	PACKAGE int marshal(pj_BufferHandle bh, int offset)
	{
		return 0;
	}
	
	PACKAGE int unmarshal(pj_BufferHandle bh, int offset)
	{
		return 0;
	}
}
