/*
 * ARPHandler.Java
 *
 * Copyright (c) 2000 The University of Utah and the Flux Group.
 * All rights reserved.
 * 
 * This file is part of the Janos Java NodeOS software.
 * 
 * Permission to use, copy, modify, distribute, and sell this software and
 * its documentation is hereby granted without fee, provided that the above
 * copyright notice and this permission/disclaimer notice is retained in all
 * copies or modified versions, and that both notices appear in supporting
 * documentation.  THE COPYRIGHT HOLDERS PROVIDE THIS SOFTWARE "AS IS" AND
 * WITHOUT ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION,
 * THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE.  THE COPYRIGHT HOLDERS DISCLAIM ANY LIABILITY OF ANY KIND FOR
 * ANY DAMAGES WHATSOEVER RESULTING FROM THE USE OF THIS SOFTWARE.
 * 
 * Users are requested, but not required, to send to csl-dist@cs.utah.edu any
 * improvements that they make and grant Univ. of Utah redistribution rights.
 */
package JANOS_SERVICES_PKG.arp;

/**
 * Simple wrapper for the Moab arplib.
 *
 * Just reference it to initialize.
 */
public class ARPHandler
{
	static 
	{
		init();
	}
	
	private static native void init();

	/**
	 * Setup an interface to respond to remote ARPs.
	 */
	public static native void config_iface(int iface, byte[] ipaddr);

	/**
	 * Ask for an IP address's ethaddr via a specific interface
	 */
	public static native int arpfor(int iface, byte[] ipaddr, byte[] ethaddr);

	/**
	 * Get the hardware address associated with the given iface on this node.
	 */
	public static native void find_ethaddr(int iface, byte[] myEthAddr);

	private static native void destroy();
}
