/*
 * LogCheck.Java
 *
 * Copyright (c) 1999, 2000, 2001, 2002 The University of Utah and the Flux Group.
 * All rights reserved.
 * 
 * This file is part of the Janos Java NodeOS software.
 * 
 * Permission to use, copy, modify, distribute, and sell this software and
 * its documentation is hereby granted without fee, provided that the above
 * copyright notice and this permission/disclaimer notice is retained in all
 * copies or modified versions, and that both notices appear in supporting
 * documentation.  THE COPYRIGHT HOLDERS PROVIDE THIS SOFTWARE "AS IS" AND
 * WITHOUT ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION,
 * THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE.  THE COPYRIGHT HOLDERS DISCLAIM ANY LIABILITY OF ANY KIND FOR
 * ANY DAMAGES WHATSOEVER RESULTING FROM THE USE OF THIS SOFTWARE.
 * 
 * Users are requested, but not required, to send to csl-dist@cs.utah.edu any
 * improvements that they make and grant Univ. of Utah redistribution rights.
 */
package JANOS_TESTS_PKG;

import JANOS_UTIL_PKG.DomainBase;
import JANOS_NODEOS_PKG.Node;
import JANOS_NODEOS_PKG.Domain;
import JANOS_IO_PKG.Log;
import JANOS_IO_PKG.LogListener;

/**
 * Take a good guess.
 */
public class LogCheck
	extends DomainBase
	implements LogListener
{
	public LogCheck()
	{
	}

	public void start()
	{
		Throwable th;
		Log l = new Log("TestLog");

		l.addListener(this);

		l.logMsg(Log.EMERG, "EMERG");
		l.logMsg(Log.ALERT, "ALERT");
		l.logMsg(Log.CRIT, "CRIT");
		l.logMsg(Log.ERR, "ERR");
		l.logMsg(Log.INFO, "INFO");
		l.logMsg(Log.WARNING, "WARNING");
		l.logMsg(Log.NOTICE, "NOTICE");
		l.logMsg(Log.DBG, "DBG");

		/*
		 * don't log exceptions, as the backtraces vary
		 * dramatically between Kaffe and Sun's JVMs.
		 */
#if 0
		l.logMsg(Log.DBG, "message 2, exception 1:");
		th = new Throwable("1st throwable");
		l.logThrowable(Log.DBG, th);
		l.logMsg(Log.WARNING, "message 3");
		th = new Throwable("2nd throwable");
		l.logThrowable(Log.DBG, th);
#endif
		
		this.domain.destroy();
	}

	public void logMsg(int level, String msg)
	{
		Node.println("Message (" +level+ ") : " +msg);
	}
}
