/*
 * AddressFactoryTester.Java
 *
 * Copyright (c) 1999, 2000, 2001 The University of Utah and the Flux Group.
 * All rights reserved.
 * 
 * This file is part of the Janos Java NodeOS software.
 * 
 * Permission to use, copy, modify, distribute, and sell this software and
 * its documentation is hereby granted without fee, provided that the above
 * copyright notice and this permission/disclaimer notice is retained in all
 * copies or modified versions, and that both notices appear in supporting
 * documentation.  THE COPYRIGHT HOLDERS PROVIDE THIS SOFTWARE "AS IS" AND
 * WITHOUT ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION,
 * THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE.  THE COPYRIGHT HOLDERS DISCLAIM ANY LIABILITY OF ANY KIND FOR
 * ANY DAMAGES WHATSOEVER RESULTING FROM THE USE OF THIS SOFTWARE.
 * 
 * Users are requested, but not required, to send to csl-dist@cs.utah.edu any
 * improvements that they make and grant Univ. of Utah redistribution rights.
 */

package JANOS_TESTS_NODEOS_PKG;

import java.net.InetAddress;

import JANOS_TESTS_PKG.*;

import JANOS_NODEOS_PKG.Address;
import JANOS_NODEOS_PKG.AddressFactory;
import JANOS_NODEOS_PKG.NoSuchNodeAddress;

public class AddressFactoryTester extends Tester
{

	public void testUnit() throws TestFailedException
	{
		AddressFactory af;
		Address addr;

		this.enterSection(ENV_EXPOSED, "Constructor/Accessor");

		af = new AddressFactory();
		try
		{
			addr = af.newAddress(0x00010204,
					     "if/ipv4/udp",
					     "1024:localhost");
			this.test(addr.getANAddress() == 0x00010204);
			this.test(addr.getProtocolSpec().
				  equals("if/ipv4/udp"));
			this.test(addr.getAddressSpec().
				  equals("1024:localhost"));
		}
		catch(NoSuchNodeAddress e)
		{
			throw new TestFailedException(this);
		}
	}

}
