/*
 * NodeOSTester.Java
 *
 * Copyright (c) 1999, 2000 The University of Utah and the Flux Group.
 * All rights reserved.
 *
 * This file is part of the Janos Java NodeOS software.
 * 
 * Permission to use, copy, modify, distribute, and sell this software and
 * its documentation is hereby granted without fee, provided that the above
 * copyright notice and this permission/disclaimer notice is retained in all
 * copies or modified versions, and that both notices appear in supporting
 * documentation.  THE COPYRIGHT HOLDERS PROVIDE THIS SOFTWARE "AS IS" AND
 * WITHOUT ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION,
 * THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE.  THE COPYRIGHT HOLDERS DISCLAIM ANY LIABILITY OF ANY KIND FOR
 * ANY DAMAGES WHATSOEVER RESULTING FROM THE USE OF THIS SOFTWARE.
 * 
 * Users are requested, but not required, to send to csl-dist@cs.utah.edu any
 * improvements that they make and grant Univ. of Utah redistribution rights.
 */

package JANOS_TESTS_NODEOS_PKG;

import JANOS_TESTS_PKG.*;

public class NodeOSTester extends Tester
{
	public void testUnit() throws TestFailedException
	{
		int lpc;

		String classes[] =
		{
			"AddressFactoryTester",
			"AddressTester",
			"BufferHandleTester",
			"BufferTester",
			"ClassInstantiationKeyTester",
			"CommQueueTester",
			"CommSpaceElementTester",
			"CommSpaceHandleTester",
			"CredentialsTester",
			"DemultiplexKeyTester",
			"DomainClassLoaderTester",
			"InChannelTester",
			"OutChannelTester",
			"SemaphoreTester",
			"WorkItemTester"
		};
		
		this.enterSection(ENV_NONE, "NodeOS Classes");
		for( lpc = 0; lpc < classes.length; lpc++ )
		{
			Tester.testClass(JANOS_TESTS_NODEOS_PKG_S
					 + "."
					 + classes[lpc]);
		}
	}
}
