/*
 * FreeList.Java
 *
 * Copyright (c) 1999 The University of Utah and the Flux Group.
 * All rights reserved.
 * 
 * This file is part of the Janos Java NodeOS software.
 * 
 * Permission to use, copy, modify, distribute, and sell this software and
 * its documentation is hereby granted without fee, provided that the above
 * copyright notice and this permission/disclaimer notice is retained in all
 * copies or modified versions, and that both notices appear in supporting
 * documentation.  THE COPYRIGHT HOLDERS PROVIDE THIS SOFTWARE "AS IS" AND
 * WITHOUT ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION,
 * THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE.  THE COPYRIGHT HOLDERS DISCLAIM ANY LIABILITY OF ANY KIND FOR
 * ANY DAMAGES WHATSOEVER RESULTING FROM THE USE OF THIS SOFTWARE.
 * 
 * Users are requested, but not required, to send to csl-dist@cs.utah.edu any
 * improvements that they make and grant Univ. of Utah redistribution rights.
 */
package JANOS_UTIL_PKG;

public class FreeList
{
	FreeListElement fullElements;
	FreeListElement emptyElements;

	public synchronized Object getFree()
	{
		FreeListElement e = fullElements;

		if(e != null)
		{
			fullElements = e.next;
			e.next = emptyElements;
			emptyElements = e;
			return e.o;
		}
		else return null;
	}

	public synchronized void addFree(Object o)
	{
		FreeListElement e = emptyElements;
		if(e == null) e = new FreeListElement();

		e.o = o;
		emptyElements = e.next;
		e.next = fullElements;
		fullElements = e;
	}
}

class FreeListElement
{
	Object o;
	FreeListElement next;
}

